import cPickle
import numpy as np
import matplotlib.pyplot as plt
import matplotlib.mlab as mlab
import matplotlib
from matplotlib.ticker import FuncFormatter
import pylab

def printtime(mins,pos=0):
    h = float(mins)/float(60)
    hint = int(h)
    m = (h-hint)*60
    mint = int(m)
    s = (m-mint)*60
    sint = int(s)
    return str(hint)+":"+str(mint)+":"+str(sint) 

if __name__ == "__main__":  
    serie =      ["HCM_0_100", "HCM_M_18", "HCM_M_40", "HCM_M_45", "HCM_M_50", "HCM_M_55", "HCM_M_60", "HCM_M_65", "HCM_M_70",
                    "HCM_N_18", "HCM_N_35", "HCM_N_40", "HCM_N_45", "HCM_N_50", "HCM_N_55", "HCM_N_60"]
    age = [ 0, 18, 40, 45, 50, 55, 60, 65, 70, 18, 35, 40, 45, 50, 55, 60 ]
    
    n_serie = 16
    data = []
    for n_serie in [0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15]:
        datafile = cPickle.load(open( serie[n_serie], 'rb'))
        print " loaded ", len(datafile)," times from disk"
        timelist=datafile
        mu = np.average(timelist)
        std = np.std(timelist)
        item = [serie[n_serie], mu, std ]
        data.append(item)
        
    fig = plt.figure()
    ax = fig.add_subplot(111)
    # histogram
    #n, bins, patches = ax.hist( timelist , max( 20 , len(datafile)/10 ) , normed=0, facecolor='green', alpha=0.75)
    ax.plot( [30, 75] , [ data[0][1] , data[0][1] ], 'g-' )
    ax.plot( [30, 75] , [ data[0][1] + data[0][2] , data[0][1]  + data[0][2] ], 'g--' )
    ax.plot( [30, 75] , [ data[0][1] - data[0][2], data[0][1]  - data[0][2] ], 'g-.' )
    
    ax.plot( [30, 75] , [ data[1][1] , data[1][1] ], 'b-' )
    ax.plot( [30, 75] , [ data[1][1] + data[1][2] , data[1][1]  + data[1][2] ], 'b--' )
    ax.plot( [30, 75] , [ data[1][1] - data[1][2], data[1][1]  - data[1][2] ], 'b-.' )
    
    ax.plot( [30, 75] , [ data[9][1] , data[9][1] ], 'r-' )
    ax.plot( [30, 75] , [ data[9][1] + data[9][2] , data[9][1]  + data[9][2] ], 'r--' )
    ax.plot( [30, 75] , [ data[9][1] - data[9][2], data[9][1]  - data[9][2] ], 'r-.' )
    
    for n_serie in [2,3,4,5,6,7,8,10,11,12,13,14,15]:
        print n_serie," : ",
        xoff = 0
        symb=''
        if n_serie < 10:
            xoff = +0.5
            symb = 's'
        else:
            xoff = -0.5
            symb = 'o'

        x = age[n_serie] + xoff
        print x
        y = data[n_serie][1]
        y_error = data[n_serie][2]
        ax.errorbar(x, y, yerr=y_error, xerr=None,
         fmt=symb, ecolor=None, elinewidth=None, capsize=3,
         barsabove=False, lolims=False, uplims=False,
         xlolims=False, xuplims=False)

    
    #plt.legend( ('KAIKKI','','', 'MIEHET','','', 'NAISET','N mu+s','N mu-s'))
    ax.set_title('Helsinki City Marathon, 14.8.2010')
    ax.set_ylabel('Time')
    ax.set_xlabel('Age')
    #mu = np.average(timelist)
    #std = np.std(timelist)
    #pylab.text(5.3*60, 0.5*max(n), '%s\nN=%i\nmu=%s\nsigma=%s'%(serie[n_serie],len(timelist), printtime(mu), printtime(std)))
    
    #mux=[mu , mu]
    #muy=[0 , 450]
    #splus=[mu+std , mu+std]
    #sminus=[mu-std , mu-std]
    #plt.plot(mux,muy, 'r--')
    #plt.plot(splus,muy, 'r--')
    #plt.plot(sminus,muy, 'r--')
    #locs = []
    #tloc = 30
    #locs.append(tloc)
    #while tloc<75:
    #    tloc=tloc+5
    #    locs.append(tloc)
        
    #locs =[100, 200, 300]
    #ax.xaxis.set_major_locator( matplotlib.ticker.FixedLocator( locs )  )
    
    ylocs = []
    tloc = 120
    ylocs.append(tloc)
    while tloc<7*60:
        tloc=tloc+15
        ylocs.append(tloc)
    ax.yaxis.set_major_locator( matplotlib.ticker.FixedLocator( ylocs )  )
    
    formatter = FuncFormatter(printtime)
    ax.yaxis.set_major_formatter(formatter)
    #fig.autofmt_xdate(rotation=90)
    ax.set_xlim(30, 75)
    ax.set_ylim( 2*60, 6.5*60)
    ax.grid(True)
    plt.savefig( "age_fig.png")
    plt.show()
    #plt.savefig( serie[n_serie]+"_fig.png")
